diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/age_class.c linux-kgdb/fs/reiserfs/age_class.c
--- /usr/src/linux-2.4.9/fs/reiserfs/age_class.c	Thu Jan  1 03:00:00 1970
+++ linux-kgdb/fs/reiserfs/age_class.c	Sat Aug 25 17:18:36 2001
@@ -0,0 +1,211 @@
+/*
+ * fs/reiserfs/age_class.c
+ *
+ * Class LRU routines for file aging and replacement.
+ *
+ * Written by Yury Shevchuk <sizif@botik.ru>
+ *
+ * Changes:
+ *      20000826 Linear interpolation for threshold calculation
+ *      proposed by Nikita Danilov <nikitadanilov@yahoo.com>
+ *
+ * Copyright 2000 Hans Reiser, see reiserfs/README for licensing and copyright details
+ *
+ * $Id: age_class.c,v 1.1.2.6 2000/09/08 14:42:45 sizif Exp $
+ */
+
+#include <linux/age_class.h>
+
+#define DUMMY(ARGS...)
+#define debug(N,M)	DUMMY
+
+#ifdef __KERNEL__
+#  include <linux/sched.h>
+#  include <linux/reiserfs_fs.h>
+#  include <linux/smp_lock.h>
+#  define assert(X)	BUG();
+#  define snprintf(STR, N, FMT, ARGS...)  sprintf (STR, FMT, ## ARGS)
+#  define SAFETY_MARGIN 100
+#else
+#  define SAFETY_MARGIN 0	/* not needed if snprintf is available */
+#endif
+
+
+void
+age_class_init (age_class *a, time_t curtime)
+{
+    int i = AGE_CLASS_COUNT;
+    while (--i >= 0) {
+	a->class[i].c = 0;
+	a->class[i].t = curtime;
+    }
+    a->total = 0;
+}
+
+
+/* count object with timestamp TIME in appropriate class (INC=1 for
+   arrival, INC=-1 for departure) */
+
+void
+age_class_update (age_class *a, time_t time, int inc)
+{
+    int n = age_class_find (a, time);
+    unsigned old = a->class[n].c;
+    unsigned new = a->class[n].c + inc;
+
+    if ((old^new) & 0x80000000) {
+	/* Counter overflow can occur if you have too many (>> 4G)
+	   objects -- use 64 bit counters then, while underflow means
+	   an error somewhere (missing positive update) */
+	debug(86, 1)
+	  ("age_class_update: class[%u].c = %u + (%d) would overflow, refusing\n",
+	   n, old, inc);
+	return;
+    }
+
+    a->class[n].c = new;
+    a->total += inc;
+}
+
+
+/* find age class where timestamp TIME currently belongs */
+
+int
+age_class_find (age_class *a, time_t time)
+{
+    int i;
+    for (i = 0; i < AGE_CLASS_COUNT; i++) {
+	if (time >= a->class[i].t)
+	    return i;
+    }
+    assert (0);
+    return 0;
+}
+
+
+/* The periodical shift procedure.  Returns 0 if shift isn't done
+   because class0 isn't big enough */
+
+int
+age_class_shift (age_class *a, time_t curtime)
+{
+    unsigned long min;
+    int i, chosen;
+
+    /* Don't shift unless class[0].c is big enough, and time interval
+       is wider than zero. */
+    if (a->class[0].c <= a->total/AGE_CLASS_COUNT
+	|| a->class[0].t >= curtime)
+	return 0;
+
+    /* Consider all neighbouring class pairs to find the pair to
+       merge.  We will merge the pair for which the sum of the
+       counters is minimal. */
+
+    min = ULONG_MAX;
+    chosen = 1;
+
+    for (i = 1; i < AGE_CLASS_COUNT; i++) {
+	int sum = a->class[i-1].c + a->class[i].c;
+	if (sum < min) {
+	    min = sum;
+	    chosen = i;
+	}
+    }
+
+    debug(86, 5) ("age_class_shift: shift up to class[%u]\n", chosen);
+
+    i = chosen-1;
+    a->class[i+1].c += a->class[i].c;
+    a->class[i].t = a->class[i-1].t;
+    while (--i > 0) {
+        a->class[i+1].c = a->class[i].c;
+	a->class[i].t = a->class[i-1].t;
+    }
+    a->class[1].c = a->class[0].c;
+    a->class[0].c = 0;
+    a->class[0].t = curtime;
+
+    return 1;
+}
+
+
+/* dump age_class for debugging purposes */
+
+char *
+age_class_dump (age_class *a, time_t curtime, char *buf, int bufsz)
+{
+    char *p = buf;
+    int room_left = bufsz - SAFETY_MARGIN;
+    time_t t = curtime;
+    int i;
+
+    for (i = 0; i < AGE_CLASS_COUNT; i++) {
+	int n = snprintf (p, room_left, 
+			  "  class %02d: files %-12u span %10ld..%-10ld = %-10ld\n",
+			  i, a->class[i].c, a->class[i].t+1, t, t-a->class[i].t);
+	p += n;
+	if ((room_left -= n) <= 0)
+	    break;
+	t = a->class[i].t;
+    }
+    if (room_left > 0) {
+	int n = snprintf (p, room_left, 
+			  "  total     files %-12u\n", a->total);
+	p += n;
+	room_left -= n;
+    }
+    return buf;
+}
+
+
+/* Compute age threshold based on desired file ratio.  The ratio is
+   defined as M/N*100 where M is the count of files above threshold, N
+   is the total number of files.  For example, for ratio=20 threshold
+   will be chosen so that every 5th file will be above the threshold. */
+
+time_t
+age_class_threshold (age_class *a, unsigned ratio, time_t curtime)
+{
+    unsigned long aged = 0;
+    unsigned long r1, r2 = 0;
+    time_t t1, t2;
+    int i = AGE_CLASS_COUNT;
+
+    /* We should never be called if there are no files,
+       but let's play safe */
+    if (! a->total)
+	return 0;
+
+    t1 = t2 = r1 = 0;   /* only to avoid incorrect warning */
+
+    while (--i > 0) {
+	aged += a->class[i].c;
+	if (aged == 0)
+	    continue;
+	r1 = r2;
+	r2 = aged*100/a->total;
+	if (r2 >= ratio) {
+	    t1 = a->class[i].t;
+	    t2 = a->class[i-1].t;
+	    break;
+	}
+    }
+
+    if (i == 0) {
+	r1 = r2;
+	r2 = 100;
+	t1 = a->class[0].t;
+	t2 = curtime;
+    }
+
+    /* Now the threshold is within class i, r1 <= ratio <= r2, (r1 != r2),
+       t1 <= age_threshold <= t2.  Interpolate to find the threshold  */
+
+    return t1 + (t2-t1)*(ratio - r1)/(r2-r1);
+}
+
+/*
+  ;;; Local Variables: ***
+  ;;; tab-width:8 ***
+*/
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/dir.c linux-kgdb/fs/reiserfs/dir.c
--- /usr/src/linux-2.4.9/fs/reiserfs/dir.c	Sat Jul 21 20:20:56 2001
+++ linux-kgdb/fs/reiserfs/dir.c	Sat Aug 25 17:48:44 2001
@@ -28,6 +28,7 @@ struct file_operations reiserfs_dir_oper
     read:	generic_read_dir,
     readdir:	reiserfs_readdir,
     fsync:	reiserfs_dir_fsync,
+    ioctl:      reiserfs_dir_ioctl,
 };
 
 /*
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/inode.c linux-kgdb/fs/reiserfs/inode.c
--- /usr/src/linux-2.4.9/fs/reiserfs/inode.c	Sat Jul 21 20:20:56 2001
+++ linux-kgdb/fs/reiserfs/inode.c	Sun Aug 26 02:44:30 2001
@@ -58,7 +58,7 @@ void reiserfs_delete_inode (struct inode
     unlock_kernel() ;
 }
 
-static void _make_cpu_key (struct cpu_key * key, int version, __u32 dirid, __u32 objectid, 
+void _make_cpu_key (struct cpu_key * key, int version, __u32 dirid, __u32 objectid, 
 			   loff_t offset, int type, int length)
 {
   key->version = version;
@@ -923,6 +923,17 @@ static void init_inode (struct inode * i
 	    inode->i_generation = INODE_PKEY (inode)->k_dir_id;
 	else
 	    inode->i_generation = le32_to_cpu( sd->u.sd_generation );
+#ifdef CONFIG_REISERFS_RAW
+        if (ih->ih_item_len == RAW_SD_SIZE) {
+            inode->u.reiserfs_i.lastref = le32_to_cpu (ATTR_LASTREF (sd));
+            inode->u.reiserfs_i.expires = le32_to_cpu (ATTR_EXPIRES (sd));
+            inode->u.reiserfs_i.user1   = le32_to_cpu (ATTR_USER1 (sd));
+        }
+        else {
+            /* make raw/non-raw inodes clearly distinguishable */
+            inode->u.reiserfs_i.lastref = 0;
+        }
+#endif
     }
 
     /* nopack = 0, by default */
@@ -947,7 +958,7 @@ static void init_inode (struct inode * i
 
 
 // update new stat data with inode fields
-static void inode2sd (void * sd, struct inode * inode)
+void inode2sd (void * sd, struct inode * inode)
 {
     struct stat_data * sd_v2 = (struct stat_data *)sd;
 
@@ -1010,7 +1021,15 @@ static void update_stat_data (struct pat
 	// path points to old stat data
 	inode2sd_v1 (B_I_PITEM (bh, ih), inode);
     } else {
-	inode2sd (B_I_PITEM (bh, ih), inode);
+        struct stat_data *sd = (struct stat_data *)B_I_PITEM (bh, ih);
+        inode2sd (sd, inode);
+#ifdef CONFIG_REISERFS_RAW
+        if (ih->ih_item_len == RAW_SD_SIZE) {
+            ATTR_LASTREF(sd) = cpu_to_le32 (inode->u.reiserfs_i.lastref);
+            ATTR_EXPIRES(sd) = cpu_to_le32 (inode->u.reiserfs_i.expires);
+            ATTR_USER1(sd)   = cpu_to_le32 (inode->u.reiserfs_i.user1);
+        }
+#endif
     }
 
     return;
@@ -1131,21 +1150,61 @@ void reiserfs_read_inode2 (struct inode 
 }
 
 
+/*
+ * For fs mounted in raw mode, we want 64bit inode numbers (in raw
+ * mode they serve as filenames, and we want to minimize collision
+ * probability).  Hence the need for find_actor.  For non-raw fs it
+ * is not used, so no harm to efficiency.
+ */
+static int
+reiserfs_find_actor(struct inode *inode, unsigned long ino, void *opaque)
+{
+    struct reiserfs_iget4_args *args = opaque;
+    __u32 dir_id = args->objectid;
+
+    return (dir_id == INODE_PKEY(inode)->k_dir_id);
+}
+
 struct inode * reiserfs_iget (struct super_block * s, struct cpu_key * key)
 {
     struct inode * inode;
     struct reiserfs_iget4_args args ;
+    find_inode_t find_actor = reiserfs_raw(s)? reiserfs_find_actor : NULL;
 
     args.objectid = key->on_disk_key.k_dir_id ;
+    inode = iget4 (s, key->on_disk_key.k_objectid, find_actor, &args);
+#if 0
     inode = iget4 (s, key->on_disk_key.k_objectid, 0, (void *)(&args));
     if (!inode) 
       return inode ;
-
+    
     if (comp_short_keys (INODE_PKEY (inode), key) || is_bad_inode (inode)) {
-	/* either due to i/o error or a stale NFS handle */
-	iput (inode);
-	inode = 0;
+      /* either due to i/o error or a stale NFS handle */
+      iput (inode);
+      inode = 0;
     }
+#endif
+    if (inode && is_bad_inode (inode)) {
+        if (reiserfs_raw (inode->i_sb)) 
+            /* In RAW mode, query for nonexistent inode is part of
+               normal operation -- just like attempts to open
+               nonexistent file in normal mode.  If we iput() the
+               resulting bad inode as is, the inode will stay in
+               i-cache, which results in cluttering i-cache with bad
+               inodes.  To avoid that, we drop i_nlink so iput can
+               destroy the inode at once */
+            inode->i_nlink = 0;
+        else
+          /* In normal mode, bad inodes are rare exception */
+            reiserfs_warning ("vs-13048: reiserfs_iget: "
+                              "bad_inode. Stat data of (%lu %lu) not found\n",
+                              key->on_disk_key.k_dir_id, key->on_disk_key.k_objectid);
+        iput (inode);
+        inode = 0;
+    }
+    if (! inode)
+        inode = ERR_PTR (-ENOENT);
+    
     return inode;
 }
 
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/ioctl.c linux-kgdb/fs/reiserfs/ioctl.c
--- /usr/src/linux-2.4.9/fs/reiserfs/ioctl.c	Thu Mar 22 06:28:56 2001
+++ linux-kgdb/fs/reiserfs/ioctl.c	Sat Aug 25 20:21:43 2001
@@ -27,14 +27,73 @@
 int reiserfs_ioctl (struct inode * inode, struct file * filp, unsigned int cmd,
 		unsigned long arg)
 {
+    struct reiserfs_raw_ioctl_arg ra;
+    struct reiserfs_raw_ioctl_arg *user_ra = (struct reiserfs_raw_ioctl_arg *)arg;
+
 	switch (cmd) {
 	    case REISERFS_IOC_UNPACK:
 		if (arg)
 		    return reiserfs_unpack (inode, filp);
-			
+                return -ENOTTY;
+
+#ifdef CONFIG_REISERFS_RAW
+            case REISERFS_IOC_RAWSETATTR:
+                if (copy_from_user (&ra, user_ra, sizeof ra))
+                    return -EFAULT;
+                return reiserfs_rawsetattr_f (inode, &ra);
+#endif /* CONFIG_REISERFS_RAW */
+            
 	    default:
 		return -ENOTTY;
 	}
+}
+
+int reiserfs_dir_ioctl (struct inode * inode, struct file * filp, unsigned int cmd,
+                        unsigned long arg)
+{
+    struct reiserfs_raw_ioctl_arg ra;
+    struct reiserfs_raw_ioctl_arg *user_ra = (struct reiserfs_raw_ioctl_arg *)arg;
+    int r;
+
+    switch (cmd) {
+#ifdef CONFIG_REISERFS_RAW
+    case REISERFS_IOC_RAWOPEN:
+        if (copy_from_user (&ra, user_ra, sizeof ra))
+            return -EFAULT;
+        if ((r = reiserfs_rawopen (inode, filp->f_vfsmnt, &ra)) < 0)
+            return r;
+        if (copy_to_user (user_ra, &ra, sizeof ra))
+            return -EFAULT;
+        return r;               /* fd */
+
+    case REISERFS_IOC_RAWCREAT:
+        if (copy_from_user (&ra, user_ra, sizeof ra))
+            return -EFAULT;
+        return reiserfs_rawcreat (inode, filp->f_vfsmnt, &ra);
+
+    case REISERFS_IOC_RAWUNLINK:
+        if (copy_from_user (&ra, user_ra, sizeof ra))
+            return -EFAULT;
+        return reiserfs_rawunlink (inode, &ra);
+
+    case REISERFS_IOC_RAWSETATTR:
+        if (copy_from_user (&ra, user_ra, sizeof ra))
+            return -EFAULT;
+        return reiserfs_rawsetattr (inode, &ra);
+    case REISERFS_IOC_TIMEDWAIT:
+          {
+                struct reiserfs_sigtimedwait_arg sa;
+                if( copy_from_user
+                        ( &sa, 
+                          ( struct reiserfs_sigtimedwait_arg * ) arg, sizeof sa ) )
+                  return -EFAULT;
+                return reiserfs_sigtimedwait( inode, &sa );
+          }
+#endif /* CONFIG_REISERFS_RAW */
+
+    default:
+        return -EINVAL;
+    }
 }
 
 /*
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/objectid.c linux-kgdb/fs/reiserfs/objectid.c
--- /usr/src/linux-2.4.9/fs/reiserfs/objectid.c	Sat Apr 28 00:18:08 2001
+++ linux-kgdb/fs/reiserfs/objectid.c	Sat Aug 25 18:36:21 2001
@@ -170,9 +170,9 @@ void reiserfs_release_objectid (struct r
 	}
 	i += 2;
     }
-
-    reiserfs_warning ("vs-15010: reiserfs_release_objectid: tried to free free object id (%lu)", 
-		      objectid_to_release);
+    if (! reiserfs_raw (s))
+        reiserfs_warning ("vs-15010: reiserfs_release_objectid: tried to free free object id (%lu)", 
+                          objectid_to_release);
 }
 
 
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/pgc.c linux-kgdb/fs/reiserfs/pgc.c
--- /usr/src/linux-2.4.9/fs/reiserfs/pgc.c	Thu Jan  1 03:00:00 1970
+++ linux-kgdb/fs/reiserfs/pgc.c	Sat Aug 25 19:50:45 2001
@@ -0,0 +1,459 @@
+/*
+ * fs/reiserfs/pgc.c
+ *
+ * "Passive garbage collector"
+ *
+ * Keeps disk usage within the bounds specified with pgc=L,H mount option
+ * by unlinking aged files from the blocks that pass through search_by_key.
+ * We never do any active disk scan to find aged files, we just remove them
+ * as they pass by, thus avoiding extra disk activity.
+
+   We might find it to be best to have all read-ahead reach memory
+   rather than staying in just the disk cache, so that PGC can occur
+   on it.  This would involve turning off disk read-ahead and doing it
+   in the FS.. -Hans
+
+ *
+ * Prototype by Nikita Danilov <nikitadanilov@yahoo.com>
+ * Rewritten for use with reiserfs_raw by Yury Shevchuk <sizif@botik.ru>
+ *
+ * Copyright 2000 by Hans Reiser, licensing governed by reiserfs/README
+ *
+ * $Id: pgc.c,v 1.1.4.14 2000/12/22 08:52:04 sizif Exp $ */
+
+#include <linux/fs.h>
+#include <linux/reiserfs_fs.h>
+#include <linux/sched.h>
+#include <asm/uaccess.h>
+#include <linux/smp_lock.h>
+
+
+#define PGC_DEBUG_LEVEL 1
+#define pgc_debug(N, X) \
+  do { if ((N) <= PGC_DEBUG_LEVEL) reiserfs_warning X; } while (0)
+
+/* how often to re-calculate PGC threshold (in seconds) */
+#define PGC_THRESHOLD_PERIOD	 	1
+
+/* The size of the unlink queue.  It should be big enough to contain
+   max number of unlinks we can reap from a single reiserfs node, so
+   we did't lose unlinks.  Note that the q is processed on exit from
+   reiserfs_raw syscalls, and we should account for the possibility
+   of several concurrent processes filling it...  We can make it
+   considerably big, as they are few (one unlinkq per fs mount.) */
+#define PGC_UNLINKQ_SZ			(50 + PAGE_SIZE/RAW_SD_SIZE*50)
+
+/* Size of the rescan protection store */
+#define PGC_SCAN_RECENT_SZ	(MAX_HEIGHT*6 + 2)
+
+struct pgc {
+    unsigned long lo;			/* low water mark, blocks */
+    unsigned long hi;			/* high water mark, blocks */
+    time_t age_threshold;		/* remove files older than this */
+    unsigned long age_threshold_last;   /* last recalculation time (jiffies) */
+    struct age_class age;		/* age class table */
+    struct key unlinkq[PGC_UNLINKQ_SZ];	/* keys queued for unlink */
+    int unlinkq_count;			/* unlinkq filled slot count */
+    int scan_buffer_lock;		/* flag to inhibit scan_buffer
+                                           while processing unlinkq */
+    struct buffer_head *scan_recent[PGC_SCAN_RECENT_SZ];
+    int scan_recent_idx;
+};
+
+
+
+//static read_proc_t pgc_proc_read_age_class;
+static void pgc_shift_if_nec (struct reiserfs_transaction_handle *th);
+static time_t pgc_recalc_threshold_if_nec (struct super_block *sb);
+static void pgc_save_age_class (struct reiserfs_transaction_handle *th);
+static void pgc_restore_age_class (struct super_block *sb);
+static int  pgc_push_unlinkq (struct super_block *sb, struct key *);
+
+
+
+int
+pgc_init (struct super_block *sb)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+
+    rsi->pgc = reiserfs_kmalloc (sizeof (struct pgc), GFP_KERNEL, sb);
+    if (! rsi->pgc) {
+	pgc_debug (1, ("pgc_init: no mem for PGC control data for %s\n",
+		       bdevname (sb->s_dev)));
+	return -1;
+    }
+    rsi->pgc->unlinkq_count = 0;
+    rsi->pgc->scan_buffer_lock = 0;
+    rsi->pgc->scan_recent_idx = 0;
+    rsi->pgc->age_threshold = 0;
+    rsi->pgc->age_threshold_last = jiffies;
+
+    pgc_restore_age_class (sb);
+    if (! rsi->pgc->age.total)
+        age_class_init (&rsi->pgc->age, CURRENT_TIME);
+  //reiserfs_proc_register (sb, "age_class", pgc_proc_read_age_class);
+    return 0;
+}
+
+void
+pgc_cleanup (struct super_block *sb, struct reiserfs_transaction_handle *th)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+
+  //reiserfs_proc_unregister(sb, "age_class");
+    pgc_save_age_class (th);
+    reiserfs_kfree (rsi->pgc, sizeof (struct pgc), sb);
+}
+
+
+/* Convers PGC thresholds from per cents to block counts and store
+   them in the pgc info structure */
+
+void
+pgc_set_thresholds (struct super_block * s, int lo, int hi)
+{
+    struct reiserfs_super_block * rs = SB_DISK_SUPER_BLOCK (s);
+    struct pgc *pgc = s->u.reiserfs_sb.pgc;
+
+    if (!pgc)
+	return;
+
+    pgc->lo = le32_to_cpu (rs->s_block_count)/100 * lo;
+    pgc->hi = le32_to_cpu (rs->s_block_count)/100 * hi;
+}
+
+
+
+/* The main function of PGC.  Scan reiserfs formatted node looking for
+   aged stat data; if found, unlink the files */
+
+void
+pgc_scan_buffer (struct super_block *sb, struct buffer_head *bh)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+    struct pgc *pgc = rsi->pgc;
+    time_t age_threshold;
+    int i;
+
+    if (! pgc) /* PGC disabled */
+	return;
+
+    /* not sure if we have the lock already.  Get it just in case. */
+    lock_kernel ();
+
+    /* Do nothing if called from pgc_process_unlinkq: these buffers
+       are likely scanned and all unlinkables in them are queued already */
+    if (++pgc->scan_buffer_lock > 1)
+	goto out;
+
+    /* When reiserfs_get_block works, we get the same buffer
+       repeatedly.  Remember the last buffer seen and don't rescan it.
+       More than that, remember several recently scanned buffers.  Or
+       else we get substantial number of repetitions in unlinkq, which
+       result in needless reiserfs_iget for already deleted inodes in
+       pgc_process_unlinkq */
+    i = PGC_SCAN_RECENT_SZ;
+    while (--i >= 0) {
+	if (bh == pgc->scan_recent[i])
+	    goto out;
+    }
+    if (--pgc->scan_recent_idx < 0)
+	pgc->scan_recent_idx = PGC_SCAN_RECENT_SZ-1;
+    pgc->scan_recent[pgc->scan_recent_idx] = bh;
+
+    age_threshold = pgc_recalc_threshold_if_nec (sb);
+    if (! age_threshold)
+	goto out;
+
+    for (i = 0; i < B_NR_ITEMS (bh); i++) {
+	struct item_head *ih = B_N_PITEM_HEAD (bh,i);
+
+	if (ih_item_len (ih) == RAW_SD_SIZE
+	    && ih_version (ih) == ITEM_VERSION_2
+	    && le16_to_cpu (ih->ih_key.u.k_offset_v2.k_type) == TYPE_STAT_DATA) {
+
+	    struct stat_data *sd = B_I_STAT_DATA (bh, ih);
+
+	    if (le32_to_cpu (ATTR_LASTREF (sd)) < age_threshold
+		|| le32_to_cpu (ATTR_EXPIRES (sd)) < CURRENT_TIME) {
+		/* Aged file, remove. */
+		pgc_debug (3, ("%s:%u: queuing unlink %k\n",
+			       __FILE__, __LINE__, &ih->ih_key));
+		/* However tempting it is to call reiserfs_rawunlink2
+		   right now, we will not.  It will attempt to create
+		   a transaction, while we are most likely inside an
+		   open transaction already.  If that open transaction
+		   is not joinable, journal_begin will sleep to let it
+		   finish, which means deadlock.  So queue it and
+		   remove later when we are for sure in user context. */
+		if (pgc_push_unlinkq (sb, &ih->ih_key) < 0)
+		    break;	/* queue overflow */
+	    }
+	}
+    }
+ out:
+    pgc->scan_buffer_lock--;
+    unlock_kernel ();
+}
+
+
+static int
+pgc_push_unlinkq (struct super_block *sb, struct key *kp)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+    struct pgc *pgc = rsi->pgc;
+
+    if (pgc->unlinkq_count >= PGC_UNLINKQ_SZ) {
+	reiserfs_warning ("pgc_push_unlinkq: queue full (%u), dropping victim\n",
+			  pgc->unlinkq_count);
+	return -1;
+    }
+
+    pgc->unlinkq[pgc->unlinkq_count++] = *kp;
+    return 0;
+}
+
+void
+pgc_process_unlinkq (struct super_block *sb)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+    struct pgc *pgc = rsi->pgc;
+    time_t age_threshold;
+    unsigned long starttime;
+
+    if (! pgc)			/* PGC disabled */
+	return;
+    if (! pgc->unlinkq_count)	/* nothing queued for unlink */
+	return;
+    if (pgc->scan_buffer_lock)	/* another pgc_process_unlinkq is active */
+	return;
+
+    age_threshold = pgc_recalc_threshold_if_nec (sb);
+    if (! age_threshold) {
+	/* No need for space anymore?  You're free, victims! */
+	pgc->unlinkq_count = 0;
+	return;
+    }
+
+    pgc->scan_buffer_lock++;
+    starttime = jiffies;
+
+    /* Process queue in LIFO order, so we hopefully use recently
+       cached things in CPU cache. */
+
+    while (pgc->unlinkq_count) {
+	struct key *kp = &pgc->unlinkq[--pgc->unlinkq_count];
+	struct cpu_key key;
+	struct inode *inode;
+
+				/* this is an indirect measure, we
+                                   should code to more directly avoid
+                                   doing disk I/O, and this should
+                                   become a debugging check we never
+                                   see, once you have the time to code
+                                   it....:-) -Hans */
+	if (jiffies - starttime > HZ/4) {
+	    /* Looks like the queue grew so long that the least recent
+	       keys got pushed from caches and unlinking them isn't
+	       cheap (probably involves disk access).  Purge the queue
+	       and go pick fresh victims */
+	    pgc_debug (2, ("pgc_process_unlinkq: 0.25s spent in unlinkq\n"));
+	    pgc->unlinkq_count = 0;
+	    break;
+	}
+
+	_make_cpu_key (&key, ITEM_VERSION_2,
+		       le32_to_cpu (kp->k_dir_id),
+		       le32_to_cpu (kp->k_objectid),
+		       SD_OFFSET, TYPE_STAT_DATA, 3/*key length*/);
+				/* need an iget that refuses to read
+                                   disk if reading disk is necessary */
+	inode = reiserfs_iget (sb, &key);
+	if (IS_ERR (inode)) {	/* already deleted.  Was in the queue twice? */
+	    static int i = 0;
+	    i++;
+	    if ((i & (i-1)) == 0)
+		reiserfs_warning ("pgc_process_unlinkq: %u overunlinks total\n", i);
+	    continue;
+	}
+	/* check to make sure it didn't get accessed while sitting on
+	   the unlinkq, since if it did we should not unlink it. */
+	if (inode->u.reiserfs_i.lastref < age_threshold 
+	    || inode->u.reiserfs_i.expires < CURRENT_TIME) {
+	    reiserfs_rawunlink2 (inode);
+	}
+	else {
+	    /* someone referenced the file in the last second...
+	       let it go free */
+	    iput (inode);
+	}
+    }
+
+    pgc->scan_buffer_lock--;
+}
+
+
+/* Return the coarse-grained current time for use as lastref. */
+
+time_t
+pgc_current_time (struct super_block *sb)
+{
+    struct pgc *pgc = sb->u.reiserfs_sb.pgc;
+
+    if (! pgc)
+	return CURRENT_TIME;
+    return pgc->age.class[0].t + 1;
+}
+
+
+/* Update age class counters, and schedule the update to disk in the
+   same transaction which will write updated stat data of the inode
+   that caused the update */
+
+void
+pgc_age_class_update (struct reiserfs_transaction_handle *th,
+		      time_t old_lastref,
+		      time_t new_lastref)
+{
+    struct super_block *sb = th->t_super;
+    struct pgc *pgc = sb->u.reiserfs_sb.pgc;
+
+    if (! pgc)			/* PGC disabled */
+	return;
+    if (sb->s_flags & MS_RDONLY)
+	return;
+
+    pgc_shift_if_nec (th);
+    if (old_lastref) age_class_update (&pgc->age, old_lastref, -1);
+    if (new_lastref) age_class_update (&pgc->age, new_lastref, +1);
+    pgc_save_age_class (th);
+}
+
+
+/* Periodic class counter shift procedure.  First implementation
+   attempt used timers, but that implies the need for extensive
+   locking, so we'll better do this in user context. */
+
+static void
+pgc_shift_if_nec (struct reiserfs_transaction_handle *th)
+{
+    struct super_block *sb = th->t_super;
+    struct age_class *age = &sb->u.reiserfs_sb.pgc->age;
+
+    if (age->class[0].t >= CURRENT_TIME) /* recently shifted */
+	return;
+
+    if (age_class_shift (age, CURRENT_TIME))
+	pgc_save_age_class (th);
+}
+
+
+/* Periodic age threshold update procedure: calculates age_threshold
+   for GC based on current disk usage */
+
+static time_t
+pgc_recalc_threshold_if_nec (struct super_block *sb)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+    struct reiserfs_super_block *rs = SB_DISK_SUPER_BLOCK (sb);
+    struct pgc *pgc = rsi->pgc;
+    unsigned long du = (le32_to_cpu (rs->s_block_count)
+			- le32_to_cpu (rs->s_free_blocks));
+    unsigned unlink_ratio;
+
+    if ((jiffies - pgc->age_threshold_last) < PGC_THRESHOLD_PERIOD*HZ)
+	goto out; /* don't recalculate too often. */
+
+    pgc_debug (2, ("%s:%u: used=%lu pgclo=%lu pgchi=%lu j=%lu, last=%lu\n",
+		   __FILE__, __LINE__, du, pgc->lo, pgc->hi,
+		   jiffies, pgc->age_threshold_last));
+
+    if (du < pgc->lo) {
+	/* low disk usage, no need to clean anything yet */
+	unlink_ratio = 0;
+	pgc->age_threshold = 0;
+    }
+    else {
+	/* When disk usage exceeds pgclo, we start removing; the
+	   closer to pgchi, the more aggressive.  At pgclo, we want to
+	   remove 5 files of 100 on the average, at pgchi we want to
+	   remove 95 files of 100.  TODO: see if the numbers are
+	   chosen well.  Make them configurable via /proc? */
+#define LO_RATIO 5
+#define HI_RATIO 95
+	unlink_ratio = (LO_RATIO
+			+ ((du - pgc->lo)
+			   * (HI_RATIO - LO_RATIO)
+			   / (pgc->hi - pgc->lo + 1/*avoid div by 0*/)));
+	if (unlink_ratio > HI_RATIO)
+	    unlink_ratio = HI_RATIO;
+
+	pgc->age_threshold =
+	    age_class_threshold (&pgc->age, unlink_ratio, CURRENT_TIME);
+    }
+
+    pgc->age_threshold_last = jiffies;
+
+    pgc_debug (2, ("%s:%u: unlink_ratio=%lu, set age_threshold=%lu\n",
+		   __FILE__, __LINE__,
+		   unlink_ratio, pgc->age_threshold));
+ out:
+    return pgc->age_threshold;
+}
+
+
+
+/* proc read routine for /proc/fs/reiserfs/XXX/age_class */
+/*
+static int
+pgc_proc_read_age_class (char *buffer, char **start, off_t offset,
+			 int count, int *eof, void *data)
+{
+    struct super_block *sb = (void *) data;
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+    int len = 0;
+
+    len += sprintf (&buffer[len], "Age threshold: %lu\n",
+		    rsi->pgc->age_threshold);
+
+    age_class_dump (&rsi->pgc->age, CURRENT_TIME, &buffer[len], PAGE_SIZE-len);
+    len = strlen (buffer);
+
+    if (offset >= len) {
+	*start = buffer;
+	*eof = 1;
+	return 0;
+    }
+    *start = buffer + offset;
+    if ((len -= offset) > count)
+	return count;
+    *eof = 1;
+    return len;
+}
+*/
+
+static void
+pgc_save_age_class (struct reiserfs_transaction_handle *th)
+{
+    struct super_block *sb = th->t_super;
+    struct reiserfs_super_block *rs = SB_DISK_SUPER_BLOCK (sb);
+    struct age_class *age = &sb->u.reiserfs_sb.pgc->age;
+    struct buffer_head *sbh = SB_BUFFER_WITH_SB (sb);
+
+    if (sb->s_flags & MS_RDONLY)
+	return;
+    reiserfs_prepare_for_journal (sb, sbh, 1) ;
+    /* update super block. TODO: should use cpu_to_le32 */
+    memcpy (rs->s_unused, age, sizeof (struct age_class));
+    journal_mark_dirty (th, sb, sbh);
+}
+
+static void
+pgc_restore_age_class (struct super_block *sb)
+{
+    struct reiserfs_super_block *rs = SB_DISK_SUPER_BLOCK (sb);
+    struct age_class *age = &sb->u.reiserfs_sb.pgc->age;
+
+    /* TODO: should use le32_to_cpu */
+    memcpy (age, rs->s_unused, sizeof (struct age_class));
+}
